Proxmox/setup/docker-install.sh

179 lines
5.3 KiB
Bash
Raw Normal View History

2022-04-25 17:07:44 +02:00
#!/usr/bin/env bash
2022-12-22 21:04:51 +01:00
if [ "$VERBOSE" == "yes" ]; then set -x; fi
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-03-17 11:59:04 +01:00
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-18 01:59:59 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:07:44 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 17:07:44 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-18 01:59:59 +02:00
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-18 01:59:59 +02:00
}
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-04-18 01:59:59 +02:00
}
2022-03-17 11:59:04 +01:00
2022-08-31 11:20:58 +02:00
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-08-31 11:20:58 +02:00
}
2022-04-18 01:59:59 +02:00
msg_info "Setting up Container OS "
2022-03-17 11:59:04 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-03-17 11:59:04 +01:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-03-17 11:59:04 +01:00
exit 1
fi
done
2022-04-18 01:59:59 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-03-17 11:59:04 +01:00
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-08-31 11:20:58 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-18 01:59:59 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-18 01:59:59 +02:00
msg_ok "Updated Container OS"
2022-03-17 11:59:04 +01:00
2022-04-18 01:59:59 +02:00
msg_info "Installing Dependencies"
2022-03-17 11:59:04 +01:00
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-18 01:59:59 +02:00
msg_ok "Installed Dependencies"
2022-03-17 11:59:04 +01:00
2022-03-20 22:32:32 +01:00
get_latest_release() {
2022-10-30 02:04:45 +01:00
curl -sL https://api.github.com/repos/$1/releases/latest | grep '"tag_name":' | cut -d'"' -f4
2022-03-20 22:32:32 +01:00
}
DOCKER_LATEST_VERSION=$(get_latest_release "moby/moby")
2022-03-25 01:32:10 +01:00
PORTAINER_LATEST_VERSION=$(get_latest_release "portainer/portainer")
2022-03-28 10:20:43 +02:00
DOCKER_COMPOSE_LATEST_VERSION=$(get_latest_release "docker/compose")
2022-03-20 22:32:32 +01:00
2022-04-18 01:59:59 +02:00
msg_info "Installing Docker $DOCKER_LATEST_VERSION"
2022-03-17 11:59:04 +01:00
DOCKER_CONFIG_PATH='/etc/docker/daemon.json'
mkdir -p $(dirname $DOCKER_CONFIG_PATH)
if [ "$ST" == "yes" ]; then
VER=$(curl -s https://api.github.com/repos/containers/fuse-overlayfs/releases/latest | grep "tag_name" | awk '{print substr($2, 2, length($2)-3) }')
cd /usr/local/bin
curl -sSL -o fuse-overlayfs https://github.com/containers/fuse-overlayfs/releases/download/$VER/fuse-overlayfs-x86_64
chmod 755 /usr/local/bin/fuse-overlayfs
2022-12-28 16:18:52 +01:00
echo -e '{\n "storage-driver": "fuse-overlayfs"\n}' > /etc/docker/daemon.json
cd ~
fi
2022-03-17 11:59:04 +01:00
cat >$DOCKER_CONFIG_PATH <<'EOF'
{
"log-driver": "journald"
}
EOF
sh <(curl -sSL https://get.docker.com) &>/dev/null
2022-04-18 01:59:59 +02:00
msg_ok "Installed Docker $DOCKER_LATEST_VERSION"
2022-03-17 11:59:04 +01:00
2022-08-23 19:57:59 +02:00
read -r -p "Would you like to add Portainer? <y/N> " prompt
2022-10-30 02:04:45 +01:00
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
PORTAINER="Y"
2022-03-25 01:08:00 +01:00
else
2022-10-30 02:04:45 +01:00
PORTAINER="N"
2022-03-25 01:08:00 +01:00
fi
if [[ $PORTAINER == "Y" ]]; then
2022-10-30 02:04:45 +01:00
msg_info "Installing Portainer $PORTAINER_LATEST_VERSION"
docker volume create portainer_data >/dev/null
docker run -d \
-p 8000:8000 \
-p 9000:9000 \
--name=portainer \
--restart=always \
-v /var/run/docker.sock:/var/run/docker.sock \
-v portainer_data:/data \
portainer/portainer-ce:latest &>/dev/null
msg_ok "Installed Portainer $PORTAINER_LATEST_VERSION"
2022-03-25 01:08:00 +01:00
fi
2022-08-23 19:57:59 +02:00
read -r -p "Would you like to add Docker Compose? <y/N> " prompt
2022-10-30 02:04:45 +01:00
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
DOCKER_COMPOSE="Y"
2022-03-28 10:20:43 +02:00
else
2022-10-30 02:04:45 +01:00
DOCKER_COMPOSE="N"
2022-03-28 10:20:43 +02:00
fi
if [[ $DOCKER_COMPOSE == "Y" ]]; then
2022-10-30 02:04:45 +01:00
msg_info "Installing Docker Compose $DOCKER_COMPOSE_LATEST_VERSION"
2022-03-28 10:20:43 +02:00
DOCKER_CONFIG=${DOCKER_CONFIG:-$HOME/.docker}
mkdir -p $DOCKER_CONFIG/cli-plugins
2022-10-30 02:04:45 +01:00
curl -sSL https://github.com/docker/compose/releases/download/$DOCKER_COMPOSE_LATEST_VERSION/docker-compose-linux-x86_64 -o ~/.docker/cli-plugins/docker-compose
2022-03-28 10:20:43 +02:00
chmod +x $DOCKER_CONFIG/cli-plugins/docker-compose
2022-10-30 02:04:45 +01:00
msg_ok "Installed Docker Compose $DOCKER_COMPOSE_LATEST_VERSION"
2022-03-28 10:20:43 +02:00
fi
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-03-17 11:59:04 +01:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
if [[ "${SSH_ROOT}" == "yes" ]]; then
2022-12-19 17:08:29 +01:00
sed -i "s/#PermitRootLogin prohibit-password/PermitRootLogin yes/g" /etc/ssh/sshd_config
systemctl restart sshd
fi
2022-10-30 02:04:45 +01:00
2022-04-18 01:59:59 +02:00
msg_info "Cleaning up"
2022-03-17 11:59:04 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-04-18 01:59:59 +02:00
msg_ok "Cleaned"